.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include apicall.inc

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName    db "WndClass",0
Application  db "Simple Window",0

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
.code
start:
	apicall GetModuleHandleA, NULL
	mov    hInstance,eax
	apicall GetCommandLineA
	mov    CommandLine,eax
	apicall WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	apicall ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	apicall LoadIconA,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	apicall LoadCursorA,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	apicall RegisterClassExA, addr wc
	apicall CreateWindowExA,NULL,ADDR ClassName,ADDR Application,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	apicall ShowWindow, hwnd,SW_SHOWNORMAL
	apicall UpdateWindow, hwnd
	.WHILE TRUE
		apicall GetMessageA, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		apicall TranslateMessage, ADDR msg
		apicall DispatchMessageA, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_DESTROY
		apicall PostQuitMessage,NULL
	.ELSE
		apicall DefWindowProcA,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
WndProc ENDP

END start